#ifndef comparse_h
#define comparse_h
#include <string.h>

char *stptr = NULL, *stleft = NULL;

void setarg(char *list[], const char* value, const int index)
{
  if (list[index] == NULL)
    {
      if (value == NULL)
	{
	  list[index] = NULL;
	}
      else
	{
	  list[index]= (char *)malloc(strlen(value)+1);
	  strcpy(list[index], value);
	}
    }
  else 
    {
      free(list[index]);
      if (value == NULL)
	{
	  list[index] = NULL;
	}
      else
	{
	  list[index] = (char *)malloc(strlen(value)+1);
	  strcpy(list[index], value);
	}
    }
  return;
}

void argprint(char *arg[])
{
  int index = 0;
  if(arg == NULL)
    return;
  while (arg[index] != NULL)
    {
      printf("argument[%d]: [%s] ", index, arg[index]);
      index++;
    }
  printf("\n");
  return;
}

int addarg(char ***list, const char* value)
{
  int index = 0, index2 = 0;
  char **temp;
  int index4 = 0;
  while ((*list)[index] != NULL)
    {
      index++;
    }
  if ((value == NULL) || (strcmp(value, "")==0))
    return index;
  else
    {
      temp = (char **)malloc((index+2)*sizeof(char**));
      for(index2 = 0; index2 < index; index2++)
	{
	  temp[index2] = (*list)[index2];
	}
      temp[index]=(char *)malloc(strlen(value)+1);
      strcpy(temp[index],value);
      index++;
      temp[index]=NULL;
      free(*list);
      
      *list = temp;
      return index;
    }
  return index;
}

void cleararg(char **list[])
{
  int index = 0;
  while ((*list)[index] != NULL)
    {
      index++;
    }
  for(; index >=0; index--)
    {
      free((*list)[index]);
      (*list)[index] = NULL;
    }
  free(*list);
  *list = NULL;
  return;
}
char *strxspc(char *in)
{
  char *ret;
  int idx=0,idx2=0;
  ret=(char *)malloc(strlen(in));
  while(idx<=strlen(in)+1)
    {
      if (in[idx]!=32)
	{
	  ret[idx2++]=in[idx];
	}
      idx++;
    }
  return ret;
}

char *mstrtok(char *in,const char *delim,char *d)
{
    char *temp;
    int index;

    if (in==NULL)
    {
      if (stleft == NULL)
	return NULL;
      if (stleft[0]==0)
            return NULL;
        temp=stleft;
        index=0;
        stptr=&temp[index];
        if (temp[index]==0)
        {
            stptr=NULL;
            return stptr;
        }
        while ((strchr(delim,temp[index])==NULL) && (temp[index]!=0))
            index++;
	*d=temp[index];
        if (temp[index]!=0)
            stleft=&temp[index+1];
        else
            stleft=&temp[index];
        temp[index]=0;
    }
    else
    {
        temp=in;
        index=0;
        stptr=&in[index];
        if (temp[index]==0)
        {
            stptr=NULL;
            return stptr;
        }
        while ((strchr(delim,temp[index])==NULL) && (temp[index]!=0))
            index++;
	*d=temp[index];
        if (temp[index]!=0)
            stleft=&temp[index+1];
        else
            stleft=&temp[index];
        temp[index]=0;
    }
    return stptr;
}

void addcharbeg(char **olde, char newch)
{
    char *retval;
    int idx;
    int size;
    char *old;
    
    old=*olde;
    if (old==NULL)
        size=2;
    else
        size=strlen(old)+2;
    retval=(char *)malloc(size);
    retval[0]=newch;
    for(idx=0;idx<size-2;idx++)
        retval[idx+1]=old[idx];
    retval[size-1]=0;
    if (old!=NULL) free(old);
    *olde=retval;
}

void addchar(char **olde,char newch)
{
    char *retval;
    int idx;
    int size;
    char *old;
    
    old=*olde;
    if (old==NULL)
        size=2;
    else
        size=strlen(old)+2;
    retval=(char *)malloc(size);
    for(idx=0;idx<size-2;idx++)
        retval[idx]=old[idx];
    retval[size-2]=newch;
    retval[size-1]=0;
    if (old!=NULL) free(old);
    *olde=retval;
}

#endif
