#ifndef shell_h
#define shell_h

#include <string.h>
#include <stdlib.h>
#include "comparse.h"
#include <fcntl.h>
char* path;
void addchar(char **olde,char newch)
{
    char *retval;
    int idx;
    int size;
    char *old;
    
    old=*olde;
    if (old==NULL)
        size=2;
    else
        size=strlen(old)+2;
    retval=(char *)malloc(size);
    for(idx=0;idx<size-2;idx++)
        retval[idx]=old[idx];
    retval[size-2]=newch;
    retval[size-1]=0;
    if (old!=NULL) free(old);
    *olde=retval;
}

void mrdln(char **buf,FILE *fin)
{
    char ch=0;
    if ((*buf)!=NULL) free((*buf));
    *buf=NULL;
    while ((ch!='\n'))
    {
        ch=fgetc(fin);
        if ((ch!=13) && (ch!=10)) addchar(buf,ch);    
    }
}

void changepath(char *dir)
{
  int idx;
  int done;
  char *pwd, *pwd1;
  printf("%s\n",dir);
  if (dir==NULL)
    {
    }
  else if (strcmp(dir,".")==0)
    return;
  else if(strcmp(dir,"..")==0)
    {
      done=0;
      pwd1=getenv("PWD");
      pwd=(char *)malloc(strlen(pwd1)+1);
      strcpy(pwd,pwd1);
      for(idx=strlen(pwd);idx>=0;idx--)
	{
	  if ((done==0) && (pwd[idx]=='/'))
	    {
	      if (idx==0)
		pwd[idx+1]=0;
	      else
		pwd[idx]=0;
	      done=1;
	    }
	}
      if (chdir(pwd)!=0)
	printf("Cannot change to directory %s\n",pwd);
      else
	setenv("PWD",pwd,1);
    }
  else if(dir[0]=='/')
    {
      pwd=(char *)malloc(strlen(dir)+1);
      strcpy(pwd,dir);
      if (chdir(pwd)!=0)
	printf("Cannot change to directory %s\n",pwd);
      else
	setenv("PWD",pwd,1);
    }
  else
    {
    }
}

void create(char *program, char *args [], int backgnd, int in, int out, int errout)
{
  char *token, *run, *pwdpath, *temppath;
  int ret = -1;
  printf("%s (%d)\n", program, backgnd);
  if(strcasecmp(program,"cd")==0)
    {
      changepath(args[1]);
      return;
    }
  else if (program[0] == '/')
    {
      run = (char*)malloc(strlen(program));
      strcpy(run, program);
    }
  else
    {
      if (program[0] == '.')
	{
	  pwdpath = getenv("PWD");
	  run = (char*)malloc(strlen(program) + strlen(pwdpath) + 1);
	  strcpy(run, pwdpath);
	  strcat(run, "/");
	  strcat(run, program);
	  ret=access(run, X_OK|F_OK);
	}
      else
	{
	  temppath = (char*)malloc(strlen(path));
	  strcpy(temppath, path);
	  token=strtok(temppath, ":");
	  while ((token != NULL) && (ret != 0))
	    {
	      run = (char*)malloc(strlen(program) + strlen(token)+ 1);
	      strcpy(run, token);
	      strcat(run, "/");
	      strcat(run, program);
	      printf("%s (%d)", run, backgnd);
	      ret=access(run, X_OK|F_OK);
	      printf(" ret: %d, token: %s\n", ret, token);
	      token=strtok(NULL, ":");
	      if ((ret != 0) && (token != NULL))
		free(run);
	    }
	}
    }
  if (ret==0)
    {
      if (fork()==0)
	{
	  if (in != 0)
	    {
	      close(0);
	      dup(in);
	      close(in);
	    }
	  if (out != 0)
	    {
	      close(1);
	      dup(out);
	      close(out);
	    }
	  if (errout != 0)
	    {
	      close(2);
	      dup(errout);
	      close(errout);
	    }
	  args[0] = run;
	  execvp(run, args);
	}
      else
	{
	  if(backgnd == 0)
	    wait();
	}
    }
  else
    {
      printf("bmsh: %s: command not found\n",run);
    }
  free(run);
  return;
}

int process(char *command)
{
  char *tok,*com,op,*exec;
  int state = 0, fidin = 0, fidout = 0, fiderr = 0, backgnd = 0;
  int pipeID[2];
  char *args[10];
  int index, argidx=0;
  for (index = 0; index < 10; index++)
    {
      args[index] = NULL;
    }

  /*com=strxspc(command);*/
  tok=mstrtok(command," 12<&|->",&op);
  exec = tok;
  if (tok==NULL)
    return 0;
  
  while (tok!=NULL)
    {
      if (strcmp(exec, "")==0)
	{
	  exec = tok;
	}
      if (strcasecmp(exec,"quit")==0)
	{
	  return 1;
	}
      switch (state)
	{
	case 0: 
	  switch (op)
	    {
	    case '1': 
	      args[argidx++] = tok;
	      state = 1;
	      break;
	    case '2':
	      args[argidx++] = tok;
	      state = 2;
	      break;
	    case '<':
	      args[argidx++] = tok;
	      state = 5;
	      break;
	    case '&':
	      args[argidx++] = tok;
	      backgnd = 1;
	      break;
	    case '|':
	      backgnd = 1;
	      printf("pipe: %d %d\n", pipeID[0], pipeID[1]);
	      pipe(pipeID);
	      printf("pipe: %d %d\n", pipeID[0], pipeID[1]);
	      /*fidout = pipeID[1];*/      
	      args[argidx++] = tok;
	      create(exec, args, backgnd, fidin, fidout, fiderr);
	      for (index = 0; index < 10; index++)
		{
		  args[index] = NULL;
		}
	      /*fidin = pipeID[0];*/
	      fidout = 0;
	      fiderr = 0;
	      argidx = 0;
	      state = 6;
	      break;
	    case '-':
	    case ' ':
	      if (strcmp(tok, "") != 0)
		args[argidx++]=tok;
	      break;
	    default:
	      if (strcmp(tok, "") != 0)
		args[argidx++]=tok;
	      break;
	    }
	  break;
	case 1: 
	  if (op = '>')
	    {
	      printf("here");
	      state = 3;
	    }
	  break;
	case 2: 
	  if (op = '>')
	  {
	    state = 4;
	  }
	  break;
	case 3:
	  printf("state 3\n");
	  if (strcmp(tok, "") != 0)
	    {
	      printf("tok: %s", tok);
	      fidout = open(tok, O_WRONLY|O_CREAT);
	      state = 0;
	    }	 
	  break;
	case 4:
	  if (strcmp(tok, "") != 0)
	    {
	      fiderr = open(tok, O_WRONLY|O_CREAT);
	      state = 0;
	    }
	  break;
	case 5:
	  if (strcmp(tok, "") != 0)
	    {
	      fidin = open(tok, O_RDONLY);
	      state = 0;
	    }
	  break;
	case 6: 
	  if (strcmp(tok, "") != 0)
	    {
	      exec = tok;
	    }
	  break;
	}
      tok=mstrtok(NULL," 12<&|->",&op);
      printf("op: %c \nstate:%d \ntok: %s \n", op, state, tok);
    }      
  args[argidx++] = tok;
  create(exec, args, backgnd, fidin, fidout, fiderr);
  return 0;
}

#endif
