#ifndef shell_h
#define shell_h

#include <string.h>
#include <stdlib.h>
#include "comparse.h"
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/wait.h>
char* path;

void mrdln(char **buf,FILE *fin)
{
    char ch=0;
    if ((*buf)!=NULL) free((*buf));
    *buf=NULL;
    while ((ch!='\n'))
      {
        ch=fgetc(fin);
        if ((ch!=13) && (ch!=10)) addchar(buf,ch);    
      }
    if (buf==NULL)
      addchar(buf, 0);
}

void changepath(char *newdir)
{
  int idx, idx2 = 0;
  int done, flag = 0;
  char *pwd, *pwd1;
  char *copy, *dir;
  printf("newdir variable:%s\n",newdir);
  /*take off any extra '/' at the end of the path given*/
  if (newdir!=NULL)
    {
      dir = (char*)malloc(strlen(newdir)+1);
      flag = 1;
      for (idx = 0; idx <strlen(newdir); idx++)
	{
	  if ((newdir[idx] != '/') || (newdir[idx-1] != '/'))
	    dir[idx2++] = newdir[idx];
	}
      if (idx2 >= 2)
	{
	  if ((dir[idx2-1] == '/') && (dir[idx2-2] != '.'))
	    dir[idx2-1] = 0;
	  else
	    dir[idx2] = 0;
	}
      else dir[idx2] = 0;
    }
  else 
    dir = newdir;
  printf("dir variable:%s\n",dir);
  
  /*compare dir with NULL first or segmentation fault occurs.  can't strcmp with null*/
  if ((dir==NULL) || (strcmp(dir, "~")==0) || (strcmp(dir, "-")==0) || (strcasecmp(dir, "$home")==0))
    {
      pwd=getenv("HOME");
      if (chdir(pwd)!=0)
	printf("Cannot change to directory %s\n",pwd);
      else
	setenv("PWD",pwd,1);
      if (flag == 1)
	free(dir);
      return;
    }
  else if (strcmp(dir,".")==0)
    {
      if (flag == 1)
	free(dir);
      return;
    }
  else if(strcmp(dir,"..")==0)
    {
      done=0;
      pwd1=getenv("PWD");
      pwd=(char *)malloc(strlen(pwd1)+1);
      strcpy(pwd,pwd1);
      for(idx=strlen(pwd);idx>=0;idx--)
	{
	  if ((done==0) && (pwd[idx]=='/'))
	    {
	      if (idx==0)
		pwd[idx+1]=0;
	      else
		pwd[idx]=0;
	      done=1;
	    }
	}
      if (chdir(pwd)!=0)
	printf("Cannot change to directory %s\n",pwd);
      else
	setenv("PWD",pwd,1);
    }
  else if(dir[0]=='/')
    {
      pwd=(char *)malloc(strlen(dir)+1);
      strcpy(pwd,dir);
      if (chdir(pwd)!=0)
	printf("Cannot change to directory %s\n",pwd);
      else
	setenv("PWD",pwd,1);
    }
  else if(dir[0]=='.' && dir[1]=='/')
    {
      copy = &dir[2];
      pwd1=getenv("PWD");
      pwd=(char *)malloc(strlen(pwd1)+2+strlen(copy));
      strcpy(pwd,pwd1);
      if ((pwd1[strlen(pwd1)-1]!='/') && (copy == 0))
	strcat(pwd,"/");
      strcat(pwd,copy);
      if (chdir(pwd)!=0)
	printf("Cannot change to directory %s\n", pwd);
      else
	setenv("PWD", pwd, 1);
    }
  else
    {
      pwd1=getenv("PWD");
      pwd=(char *)malloc(strlen(pwd1)+2+strlen(dir));
      strcpy(pwd,pwd1);
      if (pwd1[strlen(pwd1)-1]!='/')
	strcat(pwd,"/");
      strcat(pwd,dir);
      if (chdir(pwd)!=0)
	printf("Cannot change to directory %s\n",pwd);
      else
	setenv("PWD",pwd,1);
    }
  if (flag == 1)
    free(dir);
  return;
}

void create(char *program, char *args [], int backgnd, int in, int out, int pipeIO[][2], int pipeOP, int errout, int *wid)
{
  char *token, *run, *pwdpath, *temppath;
  int ret = -1, cid, id, status;
  printf("program [%s] background(%d)\n", program, backgnd);
  if(strcasecmp(program,"cd")==0)
    {
      printf("args[1]: %s\n", args[1]);
      changepath(args[1]);
      return;
    }
  else if(strcmp(program, "cd..")==0)
    {
      program = "cd";
      changepath("..");
      return;
    }
  else if(strcmp(program, "cd.")==0)
    {
      program = "cd";
      changepath(".");
      return;
    }
  else if(strcmp(program, "cd./")==0)
    {
      program = "cd";
      changepath("./");
      return;
    }
  else if (program[0] == '/')
    {
      run = (char*)malloc(strlen(program));
      strcpy(run, program);
      ret=access(run, X_OK|F_OK);
    }
  else
    {
      if (program[0] == '.')
	{
	  pwdpath = getenv("PWD");
	  run = (char*)malloc(strlen(program) + strlen(pwdpath) + 1);
	  strcpy(run, pwdpath);
	  strcat(run, "/");
	  strcat(run, program);
	  ret=access(run, X_OK|F_OK);
	}
      else
	{
	  temppath = (char*)malloc(strlen(path));
	  strcpy(temppath, path);
	  token=strtok(temppath, ":");
	  while ((token != NULL) && (ret != 0))
	    {
	      run = (char*)malloc(strlen(program) + strlen(token)+ 2);
	      strcpy(run, token);
	      strcat(run, "/");
	      strcat(run, program);
	      /*printf("%s (%d)", run, backgnd);*/
	      ret=access(run, X_OK|F_OK);
	      /*printf(" ret: %d, token: %s\n", ret, token);*/
	      token=strtok(NULL, ":");
	      if ((ret != 0) && (token != NULL))
		{
		free(run);
		run=NULL;
		}
	    }
	}
    }
  if (ret==0)
    {
      cid=fork();
      if (cid==0)
	{
	  printf("POP[%d]-00[%d]-01[%d]-10[%d]-11[%d]\n",pipeOP,pipeIO[0][0],pipeIO[0][1],pipeIO[1][0],pipeIO[1][1]);
	  printf("in[%d], out[%d], error[%d]\n", in, out, errout);
	  switch(pipeOP)
	    {
	    case 0:
	      printf("CASE 0: pipIO[1][1] = [%d]\n", pipeIO[1][1]);
	      close(1);
	      dup(pipeIO[1][1]); 
	      close(pipeIO[1][1]);
	      /*close(pipeIO[1][0]);*/
	      /*close(pipeIO[0][1]);
		close(pipeIO[0][0]);*/
	      break;
	    case 1:
	      close(0);
	      dup(pipeIO[0][0]);
	      close(pipeIO[0][0]);
	      printf("CASE 1: pipIO[0][0] = [%d]\n", pipeIO[0][0]);
	      close(1);
	      dup(pipeIO[1][1]);
	      close(pipeIO[1][1]);
	      printf("pipIO[1][1] = [%d]\n", pipeIO[1][1]);
	      /*close(pipeIO[1][0]);
		close(pipeIO[0][1]);*/
	      /*close(pipeIO[0][1]);
	      close(pipeIO[1][0]);****/
	      break;
	    case 2:
	      close(0);
	      dup(pipeIO[0][0]);
	      close(pipeIO[0][0]);
	      printf("CASE 2: pipIO[0][0] = [%d]\n", pipeIO[0][0]);
	      /*close(pipeIO[0][1]);*/
	      /*	close(pipeIO[1][1]);*/
	      break;
	    case 3:
	      printf("CASE 3: No pipe\n");
	      break;
	    }
	  if (in != 0)
	    {
	      close(0);
	      dup(in);
	      close(in);
	    }
	  if (out != 0)
	    {
	      close(1);
	      dup(out);
	      close(out);
	    }
	  if (errout != 0)
	    {
	      close(2);
	      dup(errout);
	      close(errout);
	    }
	   setarg(args, program, 0);
	   /*argprint(args);*/
	   execvp(run, args);
	}
      else
	{
	  printf("PARENT[%d]-00[%d]-01[%d]-10[%d]-11[%d]\n",pipeOP,pipeIO[0][0],pipeIO[0][1],pipeIO[1][0],pipeIO[1][1]);
	  printf("PARENT in[%d], out[%d], error[%d]\n", in, out, errout);
	  switch(pipeOP)
	    {
	    case 0:
	      printf("pCASE 0: pipIO[1][1] = [%d]\n", pipeIO[1][1]);
	      close(pipeIO[1][1]);
	      break;
	    case 1:
	      close(pipeIO[0][0]);
	      close(pipeIO[0][1]);
	      printf("pCASE 1: pipIO[0][0] = [%d]\n", pipeIO[0][0]);
	      close(pipeIO[1][1]);
	      printf("pipIO[1][1] = [%d]\n", pipeIO[1][1]);
	      break;
	    case 2:
	      close(pipeIO[0][0]);
	      close(pipeIO[0][1]);
	      printf("pCASE 2: pipIO[0][0] = [%d]\n", pipeIO[0][0]);
	      break;
	    case 3:
	      printf("pCASE 3: No pipe\n");
	      break;
	    }
	  /*  if (*wid != 0)
	    {
	      waitpid(*wid);
	      /*close(pipeIO[0][1]);*/
	  /* }*/
	  if(backgnd != 1)
	    {
	      waitpid(cid, &status,0);	    
	    }
	  else
	    *wid = cid;
	}
    }
  else
    {
      printf("bmsh: %s: command not found\n",program);
    }
  if (run!=NULL) free(run);
  return;
}

int process(char *command)
{
  char *tok,*com,op,*exec, *dash;
  int state = 0, fidin = 0, fidout = 0, fiderr = 0, backgnd = 0;
  int pipeID[2],pipeIO[2][2], pipemode, childmode, dmem = 0;
  char **args;
  int index, argidx=0, wid=0, dashcnt = 0;

  args = (char**)malloc(sizeof(char**));
  *args = NULL;
  addarg(&args, "programname");
  backgnd=0;
  pipeIO[0][0]=0;
  pipeIO[0][1]=0;
  pipeIO[1][0]=0;
  pipeIO[1][1]=0;
  pipemode=0;
  childmode=0;

  /*4/21  added . and ~ to the delimitor list*/
  if (command != NULL)
    tok=mstrtok(command," <&|->\t",&op);
  else tok = NULL;
  printf("tok is [%s], op is [%c]\n", tok, op);
  exec = tok;
  if (tok==NULL)
    return 0;
  
  while (tok!=NULL)
    {
      /* printf("exec: %s\n",exec);*/
      if (strcmp(exec, "")==0)
	{
	  exec = tok;
	}
      if (strcmp(exec,"")==0)
	{
	  if (op!=' ')
	    {
	      printf("bmsh: operator before command.\n");
	      return 0;
	    }
	}
      else if (((exec[0]=='1') || (exec[0]=='2')) && (op=='>'))
	{
	  printf("bmsh: operator before command.\n");
	  return 0;
	}
      if ((strcasecmp(exec,"quit")==0) || (strcasecmp(exec, "exit")==0))
	{
	  return 1;
	}
      switch (state)
	{
	case 0: 
	  switch (op)
	    {
	    case '>':
	      if (strcmp(tok,"1")==0)
		state = 1;
	      else if(strcmp(tok,"2")==0)
		state = 2;
	      break;
	    case '<':
	      if ((strcmp(tok,exec)!=0) && (strcmp(tok, " ")!=0))
		addarg(&args,tok);
	      state = 3;
	      break;
	    case '&':
	      if ((strcmp(tok,exec)!=0) && (strcmp(tok, " ")!=0))
		addarg(&args,tok);
	      backgnd = 1;
	      break;
	    case '|':
	      backgnd = 1;
	      if (pipemode ==0)
		{
		  pipe(pipeID);
		  pipeIO[1][0]=pipeID[0];
		  pipeIO[1][1]=pipeID[1];
		  pipemode=1;
		  childmode=0;
		  fidin=0;
		  fidout=0;
		  fiderr=0;
		}
	      else if (pipemode==1)
		{
		  pipemode=2;
		  childmode=1;
		  pipeIO[0][0]=pipeIO[1][0];
		  pipeIO[0][1]=pipeIO[1][1];
		  pipe(pipeID);
		  pipeIO[1][0]=pipeID[0];
		  pipeIO[1][1]=pipeID[1];
		  fidin=0;
		  fidout=0;
		  fiderr=0;
		}
	      else if (pipemode==2)
		{
		  /*close(pipeIO[0][0]);
		    close(pipeIO[0][1]);*/
		  pipeIO[0][0]=pipeIO[1][0];
		  pipeIO[0][1]=pipeIO[1][1];
		  pipe(pipeID);
		  pipeIO[1][0]=pipeID[0];
		  pipeIO[1][1]=pipeID[1];
		  childmode=1;
		  pipemode=2;
		  fidin=0;
		  fidout=0;
		  fiderr=0;
		}
	      if ((strcmp(tok,exec)!=0) && (strcmp(tok, " ")!=0))
		addarg(&args, tok);
	      printf("pipeID[0[][1]: [%d], [%d]\n", pipeID[0], pipeID[1]);
	      create(exec, args, backgnd, fidin, fidout, pipeIO, childmode, fiderr, &wid);
	      cleararg(&args);
	      args = (char**)malloc(sizeof(char**));
	      *args = NULL;
	      backgnd = 1;	      
	      fidout = 0;
	      fiderr = 0;
	      argidx = 0;
	      state = 4;
	      break;
	    case '-':
	      state = 5;
	      break;
	    case ' ':
	      if (strcmp(tok, exec)!=0)
		if (strcmp(tok, "") != 0)
		  addarg(&args,tok);
	      break;
	    default:
	      if (strcmp(tok, exec)!=0)
		if (strcmp(tok, "") != 0)
		  addarg(&args,tok);
	      break;
	    }
	  break;
      	case 1:
	  if (strcmp(tok, "") != 0)
	    {
	      fidout = open(tok, O_WRONLY|O_CREAT, S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH);
	      state = 0;
	    }	 
	  break;
	case 2:
	  if (strcmp(tok, "") != 0)
	    {
	      fiderr = open(tok, O_WRONLY|O_CREAT, S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH);
	      state = 0;
	    }
	  break;
	case 3:
	  if (strcmp(tok, "") != 0)
	    {
	      fidin = open(tok, O_RDONLY);
	      state = 0;
	    }
	  break;
	case 4: 
	  if (strcmp(tok, "") != 0)
	    {
	      exec = tok;
	      state = 0;
	    }
	  break;
	case 5:
	  dashcnt++;
	  if (op == '-')
	    {
	      break;
	    }
	  dmem = 1;
	  dash = (char*)malloc(sizeof(tok)+1);
	  strcpy(dash, tok);
	  for(index =0; index <dashcnt; index++)
	    {
	      addcharbeg(&dash, '-');
	    }
	  /*printf("dash: %s\n", dash);*/
	  addarg(&args,dash);
	  dashcnt = 0;
	  state = 0;
	  break;
	
	}
      tok=mstrtok(NULL," <&|->\t",&op);
      /*printf("op: [%c] state:%d tok: %s pipe: %d \n", op, state, tok,pipeOP);*/
    }      
  if (pipemode==0)
    {
      childmode=3;
    }
  if (pipemode==1)
    {
      /*close(pipeIO[0][0]);
      close(pipeIO[0][1]);*/
      pipeIO[0][0]=pipeIO[1][0];
      pipeIO[0][1]=pipeIO[1][1];
      pipeIO[1][0]=0;
      pipeIO[1][1]=0;
      childmode=2;
    }
  if (pipemode==2)
    {
      childmode=2;
      /*close(pipeIO[0][0]);
	close(pipeIO[0][1]);*/
      pipeIO[0][0] = pipeIO[1][0];
      pipeIO[0][1] = pipeIO[1][1];
      pipeIO[1][0]=0;
      pipeIO[1][1]=0;
    }
  if (tok!=NULL)
    {
      if (strcmp(tok, exec)!=0)
	addarg(&args,tok);
    }
  /*printf("exe: %s OP: %d",exec,pipeOP);*/
  /*argprint(args);*/
  if((pipemode!=0) || (strcmp(exec,"")!=0))
    {
      printf("p:%d,e:%s\n",pipemode,exec);
      create(exec, args, backgnd, fidin, fidout, pipeIO, childmode, fiderr, &wid);
    }
  else
    {
      printf("this\n");
    }
  /* if (pipemode==2)
    {
      close(pipeIO[1][0]);
      close(pipeIO[1][1]);
      }*/
  if (dmem == 1)
    free(dash);
  return 0;
}

#endif
